<template>
  <div>
    <q-btn
      v-bind="btnProps"
      :loading="isProcessingPDF"
      @click="onClickSendPDF"
    >
      <q-icon
        name="las la-file-download"
      />
    </q-btn>
    <q-dialog
      v-model="showSendPDFDialog"
      :full-width="!isDesktopPlatform"
    >
      <q-card style="min-width: min(500px, 80vw)">
        <q-card-section v-if="hasAlgorithmChoices">
          <div class="q-mb-md">
            <translate>
              Select the type of fertilization plans you want to send:
            </translate>
          </div>
          <q-list>
            <q-item
              tag="label"
              v-for="algo in algorithmChoices"
              :key="'algo-'+algo.id"
            >
              <q-item-section avatar>
                <q-radio
                  v-model="selectedAlgorithm"
                  :val="algo"
                  color="primary"
                />
              </q-item-section>
              <q-item-section>
                <q-item-label class="">
                  {{ algo.description }}
                </q-item-label>
                <q-item-label
                  caption
                >
                  {{ algo.name }} <span v-if="algo.provider">({{ algo.provider }})</span>
                </q-item-label>
              </q-item-section>
            </q-item>
          </q-list>
        </q-card-section>

        <q-card-section>
          <div class="q-mb-md">
            <translate>
              Send to this email address:
            </translate>
            <q-input
              v-model="email"
              type="email"
              filled
              :label="$gettext('Email address')"
              :rules="[val => validateEmailAddress(val) || $gettext('Enter a valid email address')]"
              :loading="$apollo.queries.userEmail.loading"
              :debounce="200"
              @update:model-value="displaySaveEmail = Boolean(email)"
            />
          </div>
          <div v-if="displaySaveEmail">
            <q-checkbox
              v-model="saveEmail"
              dense
              :label="$gettext('Save my email address')"
            />
          </div>
        </q-card-section>

        <q-card-section>
          <q-card-actions
            class="q-pa-none"
            align="right"
          >
            <q-btn
              class="q-mr-md"
              flat
              color="secondary"
              @click="onClickCancel"
            >
              <translate>Cancel</translate>
            </q-btn>
            <q-btn
              color="primary"
              flat
              :disable="disableSendPDF"
              @click="onClickOk"
            >
              <translate>Ok</translate>
            </q-btn>
          </q-card-actions>
        </q-card-section>
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import FertilizationPlanPDFMixin from 'src/pages/fieldbook/fertilization/mixins/FertilizationPlanPDFMixin'
import { getTileLayerUrlTemplate } from 'src/services/map/layers/layer-factory'
import queryDefaultMapBaseLayer from 'src/pages/fieldbook/fertilization/graphql/queryDefaultMapBaseLayer'
import queryFertilizationPlansForDownload from 'src/pages/fieldbook/fertilization/graphql/queryFertilizationPlansForDownload'
import queryUserEmail from 'src/pages/fieldbook/fertilization/graphql/queryUserEmail'
import mutationUpdateUserEmail from 'src/pages/fieldbook/fertilization/graphql/mutationUpdateUserEmail'

export default {
  name: 'SendByEmailAllFertilizationPlansButton',
  mixins: [PlatformMixin, FertilizationPlanPDFMixin],
  props: {
    btnProps: {
      type: Object,
      required: false,
      default: () => {
        return {
          flat: true,
          color: 'primary'
        }
      }
    }
  },
  data () {
    return {
      selectedAlgorithm: null,
      fertilizationPlansAlgorithmsIds: new Set(),
      fertilizationPlans: [],
      algorithmChoices: [],
      email: null,
      saveEmail: false,
      showSendPDFDialog: false,
      displaySaveEmail: false
    }
  },
  computed: {
    storeFertilizationAlgorithms () {
      return this.$store.state.fastplatform?.config?.fertilizationAlgorithms ?? []
    },
    disableSendPDF () {
      return (this.hasAlgorithmChoices && !this.selectedAlgorithm) || !this.validateEmailAddress(this.email)
    },
    hasAlgorithmChoices () {
      return this.algorithmChoices?.length > 1
    }
  },
  apollo: {
    userEmail: {
      query: queryUserEmail,
      notifyOnNetworkStatusChange: true,
      update (data) {
        this.email = data?.users?.[0]?.email
        return this.email
      }
    }
  },
  methods: {
    async onClickSendPDF () {
      try {
        this.isProcessingPDF = true
        this.fertilizationPlansAlgorithmsIds = new Set()
        this.selectedAlgorithm = null
        this.algorithmChoices = []
        // get the fertilization plans data
        const fertilizationPlanQueryResults = await this.$apollo.query({
          query: queryFertilizationPlansForDownload,
          variables: {
            holdingCampaignId: this.$store.state.fastplatform.holdingCampaign.id
          },
          fetchPolicy: 'network-only'
        })
        this.fertilizationPlans = fertilizationPlanQueryResults.data?.fertilization_plan?.length ? fertilizationPlanQueryResults.data.fertilization_plan : []
        // Verify the algorithm(s) used.
        this.fertilizationPlans.forEach(fertilizationPlan => {
          this.fertilizationPlansAlgorithmsIds.add(fertilizationPlan.algorithm.id)
        })
        if (this.fertilizationPlansAlgorithmsIds.size === 0) {
          // no fertilization plan to download
          this.$q.notify({
            color: 'warning',
            message: this.$gettext('No fertilization plan to download as PDF.')
          })
          this.isProcessingPDF = false
        } else if (this.fertilizationPlansAlgorithmsIds.size >= 2) {
          this.algorithmChoices = this.storeFertilizationAlgorithms.filter(algo => this.fertilizationPlansAlgorithmsIds.has(algo.id))
          this.showSendPDFDialog = true
        } else {
          this.showSendPDFDialog = true
        }
      } catch (e) {
        this.$q.notify({
          color: 'red',
          message: this.$gettext('There was an error while downloading the plan.') + ' ' + this.$gettext('You can still retry.')
        })
        this.isProcessingPDF = false
      }
    },
    async _sendPDF () {
      try {
        this.isProcessingPDF = true
        // update email address
        if (this.saveEmail && this.email) {
          this.$apollo.mutate({
            mutation: mutationUpdateUserEmail,
            variables: {
              username: this.$store.state.fastplatform.user.username,
              email: this.email
            }
          }).then(() => {
            this.$q.notify({
              color: 'positive',
              message: this.$gettext('Your email address has been updated.')
            })
          }).catch(() => {
            this.$q.notify({
              color: 'negative',
              message: this.$gettext('Your email address could not be updated.')
            })
          })
        }

        // get the default map base layer
        const defaultMapBaseLayerQueryResults = await this.$apollo.query({
          query: queryDefaultMapBaseLayer,
          fetchPolicy: 'network-only'
        })
        const defaultMapBaseLayerUrlTemplate = getTileLayerUrlTemplate(defaultMapBaseLayerQueryResults.data?.map_base_layer?.[0])
        // proceed to generate and send the pdf
        const sendByEmailInputs = {
          email: this.email,
          subject: this.$gettext('Fertilization plans'),
          body: this.$gettext('Please find attached the PDF file of your fertilization plans.'),
          filename: `${this.$store.state.fastplatform.holdingCampaign.holding.name}_${this.$store.state.fastplatform.holdingCampaign.campaign.name}${this.selectedAlgorithm?.name ? '_' + this.selectedAlgorithm.name : ''}`
        }
        const algorithmId = this.selectedAlgorithm?.id ?? this.fertilizationPlans?.[0]?.algorithm?.id
        const pdfInputs = this.getSendPDFInputs(this.fertilizationPlans, defaultMapBaseLayerUrlTemplate, sendByEmailInputs)
        await this.sendPDF(algorithmId, pdfInputs)
      } catch (e) {
        console.error('Could not send PDF', e)
        this.$q.notify({
          color: 'red',
          message: this.$gettext('There was an error while sending the plans.') + ' ' + this.$gettext('You can still retry.')
        })
      } finally {
        this.isProcessingPDF = false
      }
    },
    onClickCancel () {
      this.showSendPDFDialog = false
      this.selectedAlgorithm = null
      this.isProcessingPDF = false
      this.saveEmail = false
      this.displaySaveEmail = false
    },
    onClickOk () {
      this.showSendPDFDialog = false
      if (this.selectedAlgorithm) {
        this.fertilizationPlans = this.fertilizationPlans.filter(fertilizationPlan => fertilizationPlan.algorithm.id === this.selectedAlgorithm.id)
      }
      this._sendPDF()
    },
    validateEmailAddress (email) {
      const EMAIL_PATTERN = /^(?=[a-zA-Z0-9@._%+-]{6,254}$)[a-zA-Z0-9._%+-]{1,64}@(?:[a-zA-Z0-9-]{1,63}\.){1,8}[a-zA-Z]{2,63}$/
      return EMAIL_PATTERN.test(email)
    }
  }
}
</script>
